SystemOrganization addCategory: #'Glamour-Roassal2-Presentations'!

GLMPresentation subclass: #GLMRoassal2Presentation
	instanceVariableNames: 'painting paintingBlock view shouldPopulateSelection newViewBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal2-Presentations'!

!GLMRoassal2Presentation commentStamp: '' prior: 0!
A GLMRoassalPresentation is xxxxxxxxx.

Instance Variables
	newViewBlock:		<Object>
	painting:		<Object>
	paintingBlock:		<Object>
	shouldPopulateSelection:		<Object>
	view:		<Object>

newViewBlock
	- xxxxx

painting
	- xxxxx

paintingBlock
	- xxxxx

shouldPopulateSelection
	- xxxxx

view
	- xxxxx
!

!GLMRoassal2Presentation methodsFor: 'initialize-release' stamp: 'akevalion 2/25/2015 17:45'!
defaultActions
	self 
		act: [ :roassal |  RTZoomInMove on: roassal view view ]
		icon: GLMUIThemeExtraIcons glamorousZoomIn
		entitled: 'Zoom in'.
	self 
		act: [ :roassal |  RTZoomOutMove on: roassal view view ]
		icon: GLMUIThemeExtraIcons glamorousZoomOut
		entitled: 'Zoom out'.
	self
		act: [ :roassal | roassal view view canvas focusOnCenterScaled. roassal view view signalUpdate ]
		icon: GLMUIThemeExtraIcons glamorousZoomToFit
		entitled: 'Camera center'.
																
	self 
		act: [ :roassal | 
				| fileName |
				fileName := UITheme builder 
									fileSave: 'Enter the PNG file name'
									extensions: #('png')
									path: nil.
				fileName notNil ifTrue: [ 
					RTPNGExporter new 
								builder: roassal view view;
								fileName: fileName fullName;
								exportToFile. ]  ]
			entitled: 'Export to PNG'.
	self 
		act: [ :roassal | 
				| fileName |
				fileName := UITheme builder 
									fileSave: 'Enter the SVG file name'
									extensions: #('SVG')
									path: nil.
				fileName notNil ifTrue: [ 
					RTSVGExporter 
								exportBuilderAsSVG: roassal view view 
								filename: fileName fullName ]  ]
			entitled: 'Export to SVG'.
	self act: [ :roassal |
		| fileName |
		fileName := (RTHTML5Exporter new export: roassal view view) asUrl open.
		self openIfPossible: fileName.
		 ] entitled: 'Export to HTML'.
	self
		act: [ :roassal |
				| fileName |
				fileName := UITheme builder 
									fileSave: 'Enter the HTML file name'
									extensions: #('html')
									path: nil.
				fileName notNil ifTrue: [ 
					RTHTML5Exporter new 
						directory: fileName parent;
						fileName: fileName basename; 
						export: roassal view view.
					self openIfPossible: fileName ] ]
			entitled: 'Export to HTML...'.
			
	(Smalltalk includesKey:#RTPDFExporter) ifTrue: [ 
			self
				act: [ :roassal| (Smalltalk at: #RTPDFExporter) exportView: roassal view view ]
				entitled: 'Export to PDF...'
			 ].
			

	! !

!GLMRoassal2Presentation methodsFor: 'initialize-release' stamp: 'TudorGirba 4/15/2014 07:39'!
initialize 
	super initialize.
	newViewBlock := [ RTView new ].
	shouldPopulateSelection := true.
	self defaultActions! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
initializeView: aZeroArgBlock
	^ newViewBlock := aZeroArgBlock ! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
newView
	view := nil.
	^ self view! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
newViewBlock
	^ newViewBlock! !

!GLMRoassal2Presentation methodsFor: 'initialize-release' stamp: 'AlexandreBergel 12/26/2014 13:01'!
openIfPossible: fileName
	"
	By Sean
	
	Gofer it
	smalltalkhubUser: 'SeanDeNigris' project: 'SeansPlayground';
	package: 'NewExternalWebBrowser';
	load.

	'http://google.com' asUrl open.
	"
	#NewExternalWebBrowser asClassIfPresent: [ :cls | fileName asUrl open ]! !

!GLMRoassal2Presentation methodsFor: 'scripting' stamp: 'TudorGirba 2/13/2014 07:05'!
painting: anObject
	paintingBlock := anObject! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
paintingBlock
	^ paintingBlock! !

!GLMRoassal2Presentation methodsFor: 'rendering' stamp: 'TudorGirba 2/13/2014 07:17'!
renderGlamorouslyOn: aRenderer
	self registerAnnouncements.
	^ aRenderer renderRoassal2Presentation: self! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 10/6/2014 06:17'!
renderOn: aView
	self paintingBlock glamourValue: (
								aView asGlamorousMultiValue, 
								self entity asGlamorousMultiValue,
								self asGlamorousMultiValue ).
	aView build.
	self shouldPopulateSelection ifTrue: [
		aView view elements do: [:each |  
			each when: TRMouseLeftClick do: [:event | self selection: each model ]] ].
	self view: aView! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 08:41'!
shouldPopulateSelection
	^ shouldPopulateSelection! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 08:41'!
shouldPopulateSelection: anObject
	shouldPopulateSelection := anObject! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
view
	^ view ifNil: [ view := self newViewBlock value ]! !

!GLMRoassal2Presentation methodsFor: 'accessing' stamp: 'TudorGirba 2/13/2014 07:05'!
view: anObject
	view := anObject! !

!RTBuilder methodsFor: '*Glamour-Roassal2-Presentations' stamp: 'TudorGirba 10/5/2014 12:16'!
openWithToolbar
	^ GLMCompositePresentation new 
		title: 'Roassal painting';
		with: [:composite |
			composite roassal2 initializeView: [ self ] ];
		openOn: self! !

!RTBuilder methodsFor: '*Glamour-Roassal2-Presentations' stamp: 'TudorGirba 10/5/2014 12:16'!
openWithToolbarEntitled: aTitle
	^ self openWithToolbar title: aTitle! !

!GLMMorphicRenderer methodsFor: '*Glamour-Roassal2-Presentations' stamp: 'TudorGirba 2/13/2014 07:13'!
renderRoassal2Presentation: aPresentation
	^ GLMMorphicRoassal2Renderer render: aPresentation from: self! !

GLMExamples subclass: #GLMRoassal2Examples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal2-Presentations'!

!GLMRoassal2Examples methodsFor: 'as yet unclassified' stamp: 'AlexandreBergel 3/20/2015 15:08'!
roassalPainting
	<glmBrowser: 'Roassal painting' input: '42'>
	"self new roassalPainting openOn: 42"
	| browser |
	browser := GLMTabulator withStatusbar.
	browser column: #one; column: #two.
	browser transmit to: #one; andShow: [ :a |
		a list 
			title: 'Select and trigger from menu';
			display: [:x | 1 to: x ];
			selectionAct: [:list | 
				| value |
				value := list selection * 10. "simulate some custom setup"
				(list pane port: #customSelection) value: value ] 
			entitled:  'Multiply by 10 and then send outside'
			].
	browser transmit to: #two; from: #one port: #customSelection; andShow: [ :a |
		a roassal2
			title: 'Numbers in Roassal';
			initializeView: [ RTMondrian new ];
			painting: [:view :number | 
				view shape label.
				view nodes: (1 to: number).
				view edges connectFrom: [:each | each // 5 ].
				view layout tree ] ].
	^ browser! !

GLMScriptingEditorTemplate subclass: #GLMRoassal2Easel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal2-Presentations'!

!GLMRoassal2Easel methodsFor: 'building' stamp: 'TudorGirba 10/4/2014 08:16'!
defaultScriptBindings
	^ {#view -> RTView new}! !

!GLMRoassal2Easel methodsFor: 'building' stamp: 'TudorGirba 10/4/2014 08:33'!
defaultScriptDisplayIn: aPresentation
	^ aPresentation 
		display: 'view';
		morphicAct: [:text | RTRoassalExample new open ] icon: GLMUIThemeExtraIcons glamorousExample entitled: 'Browse basic examples'! !

!GLMRoassal2Easel methodsFor: 'building' stamp: 'TudorGirba 10/4/2014 08:15'!
defaultTitle
	^ 'Roassal Easel'! !

!GLMRoassal2Easel methodsFor: 'private' stamp: 'TudorGirba 10/4/2014 08:29'!
evaluate: script in: context for: view
	| message |
	^ [ (Smalltalk compiler requestor: self) evaluate: script in: context to: context ]
		on: Error
		do: [ :e | 
			message := e class name , ': ' , e messageText.
			self inform: message.
			view add: (RTLabel new text: message; color: Color red; element) ]! !

!GLMRoassal2Easel methodsFor: 'building' stamp: 'TudorGirba 10/4/2014 08:17'!
resultIn: a
	^ a roassal2
		title: 'View';
		painting: [ :view :bindings :script | 
					| context |
					context := GLMDoItContext with: #view -> view withAll: bindings.
					self evaluate: script in: context for: view ]! !

!RTView methodsFor: '*Glamour-Roassal2-Presentations' stamp: 'TudorGirba 10/7/2014 08:00'!
openWithToolbar
	^ GLMCompositePresentation new 
		title: 'Roassal painting';
		with: [:composite | composite roassal2 initializeView: [self ] ];
		openOn: self! !

!RTView methodsFor: '*Glamour-Roassal2-Presentations' stamp: 'TudorGirba 10/7/2014 07:38'!
openWithToolbarEntitled: aTitle
	^ self openWithToolbar title: aTitle! !

!GLMCompositePresentation methodsFor: '*Glamour-Roassal2-Presentations' stamp: 'TudorGirba 2/13/2014 07:06'!
roassal2
	^ self custom: GLMRoassal2Presentation new! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicRoassal2Renderer
	instanceVariableNames: 'myMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal2-Presentations'!

!GLMMorphicRoassal2Renderer commentStamp: '' prior: 0!
A GLMMorphicRoassalRenderer is xxxxxxxxx.

Instance Variables
	myMorph:		<Object>

myMorph
	- xxxxx
!

!GLMMorphicRoassal2Renderer methodsFor: 'rendering' stamp: 'SergeStinckwich 6/19/2014 23:25'!
actOnPresentationUpdate: ann
	| aView canvas |
	aView := ann presentation newViewBlock value.
	ann presentation renderOn: aView.
	canvas := aView view setUpCanvas.
	myMorph 
		canvas: canvas;
		extent: canvas extent.
		! !

!GLMMorphicRoassal2Renderer methodsFor: 'rendering' stamp: 'TudorGirba 4/16/2014 12:14'!
render: aRoassalPresentation
	| view |
	view := aRoassalPresentation view.
	aRoassalPresentation renderOn: view.
	aRoassalPresentation on: GLMPresentationUpdated send: #actOnPresentationUpdate: to: self.
	^ myMorph := view view setUpCanvas buildMorph! !

GLMMorphicTest subclass: #GLMRoassal2MorphicTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Roassal2-Presentations'!

!GLMRoassal2MorphicTest commentStamp: '' prior: 0!
A GLMRoassalMorphicTest is xxxxxxxxx.
!

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 2/13/2014 08:47'!
testCanvas
	| composer roassalMorph |
	composer := GLMCompositePresentation new.
	composer roassal2 painting: [:view :input | view add: RTElement new].
	window := composer openOn: 42.

	roassalMorph := self find: TRMorph in: window.
	self assert: (roassalMorph isKindOf: TRMorph)! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'AlexandreBergel 3/20/2015 15:08'!
testMondrianViewBuilder
	| composite |
	composite := GLMCompositePresentation new.
	composite roassal2 
					initializeView: [ RTMondrian new ];
					painting: [ :view | view nodes: (1 to: 42) ].
	window := composite openOn: 42.
	self assert: composite first view class = RTMondrian.
	self assert: composite first view view elements size = 42! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'AlexandreBergel 1/1/2015 20:08'!
testOpenTitled
	| v |
	v :=  RTBuilder new view.
	window := v openTitled: 'hello'! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'AlexandreBergel 1/1/2015 20:07'!
testOpenWithToolbarEntitled

	window := RTBuilder new openWithToolbarEntitled: 'hello'! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'AlexandreBergel 1/1/2015 20:09'!
testOpenWithToolbarEntitled02

	| v |
	v := RTView new.
	
	window := v openWithToolbarEntitled: 'hello'! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 2/13/2014 08:47'!
testRoassalPresentationConstructor
	| composite |
	composite := GLMCompositePresentation new.
	composite roassal2.
	self assert: composite presentations size equals: 1.
	self assert: (composite presentations anyOne isKindOf: GLMRoassal2Presentation)! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 2/13/2014 08:53'!
testUpdateUsesNewView
	| browser originalView newView |
	browser := GLMWrapper new.
	browser show: [ :a | 
		a roassal2 painting: [:view :roassal2 :input | view add: RTElement new ]].
	window := browser openOn: $d.

	originalView := (self find: TRMorph in: window) trachelCanvas.
	browser panes first presentations first update.
	newView := (self find: TRMorph in: window) trachelCanvas.
	
	self assert: newView ~~ originalView
! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 10/26/2014 23:35'!
testUpdateViewIsProperlyLaidOut
	| browser originalView newView |
	browser := GLMTabulator new.
	browser column: #one.
	browser transmit
		to: #one;
		andShow: [ :a | a roassal2 painting: [ :view :input | 
			view addAll: (RTBox elementsOn: ($a to: input)).
			RTHorizontalLineLayout on: view elements ] ].
	window := browser openOn: $d.
	originalView := browser panes first presentations first view.
	self assert: (originalView elements detect: [ :each | each model = $b ]) center x equals: 17.5.
	browser panes first presentations first update.
	newView := browser panes first presentations first view.
	self assert: (newView elements detect: [ :each | each model = $b ]) center x equals: 17.5! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'AlexandreBergel 3/20/2015 15:08'!
testZoomingActionsWorkForMondrianBuilder
	| composite |
	composite := GLMCompositePresentation new.
	composite roassal2 initializeView: RTMondrian new.
	window := composite openOn: 42.
	self assert: composite first actions size equals: 7.
	self shouldnt: (composite first actions first actOn: composite first) raise: Error.
	self shouldnt: (composite first actions second actOn: composite first) raise: Error! !

!GLMRoassal2MorphicTest methodsFor: 'tests' stamp: 'TudorGirba 1/5/2015 22:22'!
testZoomingActionsWorkForView
	| composite |
	composite := GLMCompositePresentation new.
	composite roassal2.
	window := composite openOn: 42.
	self assert: composite first actions size equals: 7.
	self shouldnt: (composite first actions first actOn: composite first) raise: Error.
	self shouldnt: (composite first actions second actOn: composite first) raise: Error.! !
